import sys, os

try:
    import arcpy
except ImportError as e:
    arcpy.AddMessage("Unable to import ArcPy from default path.  Will try " + fme_objects_path)
    #print("system path is: " + str(sys.path))


arcpy.AddMessage("Python Version: " + sys.version)



# arcpy.AddMessage("\n\n")
# arcpy.AddMessage("Attempting to load with os.add_dll_directory")

# try:
#     os.add_dll_directory(fme_objects_path)
#     arcpy.AddMessage("Successfully loaded fme objects at", fme_objects_path)
# except ImportError as e:
#     arcpy.AddMessage("Unable to import FME Objects from " + fme_objects_path)
#     arcpy.AddMessage(e)
#     arcpy.AddMessage("Python Version: " + sys.version)


sys.path.remove('C:\\Program Files\\FME\\fmeobjects\\python37')
fme_objects_path = r"C:\Program Files\FME\fmeobjects\python39"
sys.path.append(fme_objects_path)

try:
    import fmeobjects
    arcpy.AddMessage("Successfully loaded fme objects")
except ImportError as e:
    arcpy.AddMessage("Unable to import FME Objects from " + fme_objects_path)
    arcpy.AddMessage("system path is: " + str(sys.path))
    exit



def mp2obj(inputFC,modelStoreFolder):
    """Script code goes below"""
    arcpy.AddMessage("Hello World")

    inputFC_path = os.path.dirname(inputFC)
    inputFC_name = os.path.split(inputFC)[1]
    workspace = os.path.split(inputFC_path)[0]
    if not [any(ext) for ext in ('.gdb', '.mdb', '.sde') if ext in os.path.splitext(inputFC_path)]:
        print(inputFC_name + " is not a geodatabase feature class.")
        exit
    if inputFC_name not in ['ToValidate_MP','AutoAssemble_MP','Prep_MP']:
        print("inputFCName  must be one of: ToValidate_MP, AutoAssemble_MP, or Prep_MP.")
        exit

    arcpy.env.overwriteOutput = 1
    #input_mp = os.path.join(workspace, inputFeatures)
    #output_mp = os.path.join(workspace, validatedFC)
    #arcpy.AddMessage("Exporting multipatch models from " + toValidateFC + " to " + modelStore) 

    # Get working directory for this script and verify location of workbench files 
    scriptpath = os.path.dirname(os.path.realpath(__file__))

    # Full path to Workspace, example comes from the FME 2020 Training Dataset
    gdbToObj_fmw = os.path.join(scriptpath, "Multipatch2ModelStore.fmw")

    if not (os.path.isfile(gdbToObj_fmw)):
        arcpy.AddMessage("FME workbench file, " + gdbToObj_fmw + "does not exist.")
        exit
    else: 
        arcpy.AddMessage("Running FME workbench file, " + gdbToObj_fmw )

    if not (os.path.exists(modelStoreFolder)):
        arcpy.AddMessage("Target ModelStore file , " + modelStoreFolder+ "does not exist.")
        exit 

    arcpy.AddMessage("Exporting " + inputFC_name + " from " + inputFC_path + " to " + modelStoreFolder)

    #arcpy.AddMessage("Copying FC")
    #arcpy.management.CopyFeatures(input_mp, outputMPFC)

    gdbToObjrunner = fmeobjects.FMEWorkspaceRunner()
    workspace = gdbToObj_fmw
    parameters = {}
    parameters['Geodatabase'] = inputFC_path
    parameters['SelectedFeatureClass'] = "ToValidate_MP"
    parameters['OutputModelStore'] = modelStoreFolder
    parameters['Tile_Option'] = '@Value(Model_ID)_OBJ'
    parameters['Wait for Job to Complete'] = 'Yes'
    parameters['Maximum Concurrent FME Processes'] = '1'
    try:
        # Run Workspace with parameters set in above directory
        arcpy.AddMessage("Running FME Workspace: " +  gdbToObj_fmw)
        gdbToObjrunner.runWithParameters(workspace, parameters)
        arcpy.AddMessage('!!!The Workspace ' + gdbToObj_fmw + ' ran successfully!')
    except fmeobjects.FMEException as ex:
        # Print out FME Exception if workspace failed
        arcpy.AddMessage('FME Workspace ' + gdbToObj_fmw + ' failed! :(')
        arcpy.AddMessage(ex.message)

        
    # get rid of FMEWorkspace runner so we don't leave an FME process running
    gdbToObjrunner = None


    return


if __name__ == "__main__":

    inputFeatures = arcpy.GetParameterAsText(0)
    modelStoreFolder = arcpy.GetParameterAsText(1)

    mp2obj(inputFeatures,modelStoreFolder)
    #obj2mp(modelStoreFolder,outputGDB,outputFCName)
    #arcpy.SetParameterAsText(4, modelStoreFolder)