
import arcpy, sys, os

arcpy.AddMessage("Python Version: " + sys.version)
fme_objects_path = r"C:\Program Files\FME\fmeobjects\python39"
sys.path.append(fme_objects_path)


sys.path.remove('C:\\Program Files\\FME\\fmeobjects\\python37')

try:
    import fmeobjects
except ImportError as e:
    arcpy.AddMessage("Unable to import FME Objects from " + fme_objects_path)
    arcpy.AddMessage("Python Version: " + sys.version)
    print("system path is: " + str(sys.path))



def obj2mp(modelStoreFolder,outputGDB, outputFCName):
 
    objToGdb_fmw = os.path.join(scriptpath, "ModelStore2Multipatch.fmw")

    if not (os.path.isfile(objToGdb_fmw)):
        arcpy.AddMessage("FME workbench file, " + objToGdb_fmw + "does not exist.")
        exit

    objtoGDBrunner = fmeobjects.FMEWorkspaceRunner()
    workspace = objToGdb_fmw
    parameters = {}
    parameters['Output_GDB'] = outputGDB
    parameters['DestinationFCName'] = outputFCName
    parameters['ModelStore'] = modelStoreFolder
    #parameters['Tile_Option'] = '@Value(Tile_ID)_OBJ\@Value(Model_ID)_OBJ'
    try:
        # Run Workspace with parameters set in above directory
        arcpy.AddMessage("Running FME Workspace: " +  objToGdb_fmw )
        arcpy.AddMessage("Input ModelStore GDB: " +  modelStoreFolder )
        arcpy.AddMessage("Output GDB: " +  outputGDB )
        arcpy.AddMessage("Output FC Name: " +  outputFCName )
        objtoGDBrunner.runWithParameters(workspace, parameters)
        # or use promptRun to prompt for published parameters
        #runner.promptRun(workspace)
    except fmeobjects.FMEException as ex:
        # Print out FME Exception if workspace failed
        arcpy.AddMessage('FME Workspace runner ' + workspace + ' failed')
        arcpy.AddMessage(ex.message)
    else:
        #Tell user the workspace ran
        arcpy.AddMessage('The Workspace ' + objToGdb_fmw + ' ran successfully')
    # get rid of FMEWorkspace runner so we don't leave an FME process running
    objtoGDBrunner = None



if __name__ == "__main__":

    global scriptpath
    scriptpath = os.path.dirname(os.path.realpath(__file__))

    modelStoreFolder = arcpy.GetParameterAsText(0)
    outputGDB = arcpy.GetParameterAsText(1)
    outputFCName = arcpy.GetParameterAsText(2)  
    #mp2obj(inputFeatures,modelStoreFolder)
    obj2mp(modelStoreFolder,outputGDB,outputFCName)

    outputFC = os.path.join(outputGDB,outputFCName)
    arcpy.SetParameterAsText(3,outputFC)
  